#pragma once

#include "flexpage.h"
#include "memory.h"
#include "page_owner.h"
#include "page_queue.h"



/* A page collection. */

class PageCollection
{
protected:
    PageQueue *_queue;
    Memory *_memory;

public:
    explicit PageCollection(Memory *memory);

    explicit PageCollection();

    virtual ~PageCollection()
    {
    }

    virtual Flexpage *remove();

    virtual bool reserve(PageOwner *owner, Flexpage *flexpage);

    virtual Flexpage *flexpage();

    virtual void queue(PageOwner *owner, Flexpage *flexpage);

    virtual void release(Flexpage *flexpage);
};

// vim: tabstop=4 expandtab shiftwidth=4
