#pragma once

#include "page_collection.h"
#include "page_queue_partitioned.h"



/* A page collection where the pages are "conserved", meaning that they are not
   queued for reuse unless they are completely unused. */

class PagesConserving : public PageCollection
{
protected:
    PageQueuePartitioned _page_queue;

public:
    explicit PagesConserving(Memory *memory);

    explicit PagesConserving();

    /* Specialised methods. */

    virtual Flexpage *flexpage();

    /* Memory control methods. */

    virtual bool decrease(offset_t size);

    virtual bool increase(offset_t size);
};

// vim: tabstop=4 expandtab shiftwidth=4
